data:extend(
{
	----------------------------------------------------------------------------------
	{
		type = "player",
		name = "drone-surveillance",
		icon = "__Drones__/graphics/drone-surveillance-icon.png",
		flags = {"pushable", "placeable-player", "placeable-off-grid", "not-repairable", "not-on-map"},
		max_health = 1000,
		healing_per_tick = 1000,
		collision_box = {{0,0}, {0, 0}},
		collision_mask = {},
		render_layer = "air-object", 
		final_render_layer = "air-object",
		-- crafting_categories = {"crafting"},
		-- mining_categories = {"basic-solid"},
		damage_hit_tint = {r = 1, g = 0, b = 0, a = 0},
		inventory_size = 0,
		build_distance = 0,
		drop_item_distance = 0,
		reach_distance = 10000,
		reach_resource_distance = 0,
		item_pickup_distance = 1,
		loot_pickup_distance = 2,
		ticks_to_keep_gun = 0,
		ticks_to_keep_aiming_direction = 0,
		running_speed = 0.15 * drone_surveillance_speed_factor,
		distance_per_frame = 1,
		maximum_corner_sliding_distance = 0,
		subgroup = "creatures",
		order="z",
		eat =
		{
			{
				filename = "__Drones__/sound/empty.ogg",
				volume = 0,
				}
		},
		heartbeat =
		{
			{
				filename = "__Drones__/sound/empty.ogg",
				volume = 0,
			}
		},
		animations =
		{
			level1 = drone_level, 
			level2addon = drone_level, 
			level3addon = drone_level,
		},
		light =
		{
			{
				minimum_darkness = 0.3,
				intensity = 0.6,
				size = 30,
			},
			{
				type = "oriented",
				minimum_darkness = 0.3,
				picture =
				{
					filename = "__core__/graphics/light-cone.png",
					priority = "medium",
					scale = 2,
					width = 200,
					height = 200
				},
				shift = {0, -13},
				size = 2,
				intensity = 0.3
			},
		},
		mining_speed = 0,
		mining_with_hands_particles_animation_positions = {0, 0},
		mining_with_tool_particles_animation_positions = {0},
		running_sound_animation_positions = {0, 0},
	},
	----------------------------------------------------------------------------------
	{
		type = "item",
		name = "drone-surveillance",
		icon = "__Drones__/graphics/drone-surveillance-icon.png",
		-- flags = {"goes-to-quickbar", "hidden"},
		flags = {"goes-to-quickbar"},
		subgroup = "transport",
		order = "b[personal-transport]-zb",
		place_result = "drone-surveillance",
		stack_size = 10,
	},
	----------------------------------------------------------------------------------
	{
		type = "recipe",
		name = "drone-surveillance",
		enabled = false, 
		energy_required = 12, -- craft time
		ingredients =
		{
			{"electric-engine-unit", 4},
			{"iron-plate", 5},
			{"iron-gear-wheel", 5},
			{"advanced-circuit", 5},
			{"solar-panel", 2},
			{"battery", 2},
		},
		result = "drone-surveillance"
	},

}
)


local drone_maint = dupli_proto( "player", "drone-surveillance", "drone-maintenance" )
drone_maint.icon = "__Drones__/graphics/drone-maintenance-icon.png"
drone_maint.flags = {"pushable", "placeable-player", "placeable-off-grid", "not-on-map"}
drone_maint.crafting_categories = {"crafting"}
drone_maint.mining_categories = {"basic-solid"}
drone_maint.max_health = 20
drone_maint.healing_per_tick = 1
drone_maint.inventory_size = drone_maintenance_inventory_size
drone_maint.build_distance = 6
drone_maint.drop_item_distance = 6
drone_maint.reach_distance = 6
drone_maint.reach_resource_distance = 2.7
drone_maint.running_speed = 0.15 * drone_maintenance_speed_factor
drone_maint.mining_speed = 0.01
drone_maint.animations =
	{
		level1 = drone_maint_level, 
		level2addon = drone_maint_level, 
		level3addon = drone_maint_level,
	}


data:extend(
{
	----------------------------------------------------------------------------------
	drone_maint,
	----------------------------------------------------------------------------------
	{
		type = "item",
		name = "drone-maintenance",
		icon = "__Drones__/graphics/drone-maintenance-icon.png",
		-- flags = {"goes-to-quickbar", "hidden"},
		flags = {"goes-to-quickbar"},
		subgroup = "transport",
		order = "b[personal-transport]-zc",
		place_result = "drone-maintenance",
		stack_size = 10,
	},
	----------------------------------------------------------------------------------
	{
		type = "recipe",
		name = "drone-maintenance",
		enabled = false, 
		energy_required = 15, -- craft time
		ingredients =
		{
			{"electric-engine-unit", 8},
			{"iron-plate", 10},
			{"iron-gear-wheel", 10},
			{"advanced-circuit", 8},
			{"solar-panel", 5},
			{"battery", 5},
		},
		result = "drone-maintenance"
	},
}
)
