data:extend(
{
	----------------------------------------------------------------------------------
	{
		type = "beacon",
		name = "drone-antenna",
		icon = "__Drones__/graphics/drone-antenna-icon.png",
		flags = {"placeable-player", "player-creation"},
		minable = {mining_time = 1, result = "drone-antenna"},
		max_health = 300,
		order = "z",
		corpse = "big-remnants",
		dying_explosion = "medium-explosion",
		collision_box = {{-1.2, -1.2}, {1.2, 1.2}},
		selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
		allowed_effects = {"consumption", "speed", "pollution"},
		base_picture =
		{
			filename = "__Drones__/graphics/drone-antenna.png",
			width = 116,
			height = 218,
			shift = { 0.36, -2}
		},
		animation =
		{
			filename = "__Drones__/graphics/empty.png",
			width = 0,
			height = 0,
			line_length = 1,
			frame_count = 1,
			shift = { -0.03, -1.72},
			animation_speed = 0.5
		},
		animation_shadow =
		{
			filename = "__Drones__/graphics/empty.png",
			width = 0,
			height = 0,
			line_length = 1,
			frame_count = 1,
			shift = { 3.12, 0.5},
			animation_speed = 0.5
		},
		radius_visualisation_picture =
		{
			filename = "__Drones__/graphics/drone-antenna-radius-visualization.png",
			width = 12,
			height = 12
		},
		supply_area_distance = drone_antenna_radius_draw,
		energy_source =
		{
			type = "electric",
			usage_priority = "secondary-input",
			drain = drone_antenna_energy .. "kW",
			-- drain = "10kW",
		},
		vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
		-- energy_usage = "10kW",
		energy_usage = drone_antenna_energy .. "kW",
		distribution_effectivity = 0.0,
		module_specification =
		{
			module_slots = 0,
			module_info_icon_shift = {0, 0.5},
			module_info_multi_row_initial_height_modifier = -0.3
		}
	},

	----------------------------------------------------------------------------------
	{
		type = "item",
		name = "drone-antenna",
		icon = "__Drones__/graphics/drone-antenna-icon.png",
		flags = {"goes-to-quickbar"},
		subgroup = "transport",
		order = "b[personal-transport]-za",
		place_result = "drone-antenna",
		stack_size = 10
	},

	----------------------------------------------------------------------------------
	{
		type = "recipe",
		name = "drone-antenna",
		enabled = false,
		energy_required = 2,
		ingredients =
		{
			{"electronic-circuit", 15},
			{"advanced-circuit", 10},
			{"steel-plate", 8},
			{"copper-cable", 12}
		},
		result = "drone-antenna"
	},

}
)
