data:extend(
	{
		{
			type = "font",
			name = "drones_font",
			from = "default",
			border = false,
			size = 15
		},
		{
			type = "font",
			name = "drones_font_bold",
			from = "default-bold",
			border = false,
			size = 15
		},
		-- buttons main with +3*2 border = 36x36
		{
			type = "sprite",
			name = "sprite_drones_main",
			filename = "__Drones__/graphics/but-main.png",
			width = 30,
			height = 30,
		},
	}
)

--------------------------------------------------------------------------------------
local default_gui = data.raw["gui-style"].default

default_gui.drones_sprite_main_style = 
{
	type="button_style",
	parent="button_style",
	
	top_padding = 0,
	right_padding = 0,
	bottom_padding = 0,
	left_padding = 0,
	
	width = 36,
	height = 36,
	scalable = false,
}

local spacing_right = 1
local spacing_vertical = 0

default_gui.drones_frame_style = 
{
	type="frame_style",
	parent="frame_style",
	
	horizontal_spacing = spacing_right,
	vertical_spacing = 0,
	
	top_padding = 0,
	right_padding = 0,
	bottom_padding = 0,
	left_padding = 0,
    --minimal_width = 200,
}

default_gui.drones_flow_style = 
{
	type = "flow_style",
	
	horizontal_spacing = spacing_right,
	vertical_spacing = 0,
	
	top_padding = 0,
	bottom_padding = spacing_vertical,
	left_padding = 0,
	right_padding = 0,
	
	max_on_row = 0,
	resize_row_to_width = true,
	resize_to_row_height = false,
	
	graphical_set = { type = "none" },
}

default_gui.drones_label_style =
{
	type="label_style",
	parent="label_style",
	font="drones_font",
	align = "left",
	default_font_color={r=1, g=1, b=1},
	hovered_font_color={r=1, g=1, b=1},
	
	top_padding = 0,
	right_padding = 0,
	bottom_padding = 0,
	left_padding = 0,
}

default_gui.drones_button_style = 
{
	type="button_style",
	parent="button_style",
	font="drones_font_bold",
	align = "center",
	default_font_color={r=1, g=1, b=1},
	hovered_font_color={r=1, g=1, b=1},
	top_padding = 0,
	right_padding = 2,
	bottom_padding = 0,
	left_padding = 2,
	height = 26,
	left_click_sound =
	{
		{
		  filename = "__core__/sound/gui-click.ogg",
		  volume = 1
		}
	},
}

default_gui.drones_textfield_style =
{
    type = "textfield_style",
	parent="textfield_style",
	font="drones_font_bold",
	align = "left",
    font_color = {},
	default_font_color={r=1, g=1, b=1},
	hovered_font_color={r=1, g=1, b=1},
    selection_background_color= {r=0.66, g=0.7, b=0.83},
	top_padding = 0,
	bottom_padding = 0,
	left_padding = 0,
	right_padding = spacing_right,
	minimal_width = 350,
	maximal_width = 350,
	graphical_set =
	{
		type = "composition",
		filename = "__core__/graphics/gui.png",
		priority = "extra-high-no-scale",
		corner_size = {3, 3},
		position = {16, 0}
	},
}    

