data:extend({
  {
    type = "roboport",
    name = "Robot-Charge-Station",
    icon = "__RoboCharge__/graphics/Robot-Charge-Station-icon.png",
    flags = {"placeable-player", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "Robot-Charge-Station"},
    max_health = 300,
    corpse = "medium-remnants",
    collision_box = {{-0.7, -0.7}, {0.7, 0.7}},
    selection_box = {{-1, -1}, {1, 1}},
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
      input_flow_limit = "5MW",
      buffer_capacity = "100MJ"
    },
    recharge_minimum = "40MJ",
    energy_usage = "50kW",
    -- per one charge slot
    charging_energy = "1000kW",
    logistics_radius = 10,
    construction_radius = 15,
    charge_approach_distance = 5,
    robot_slots_count = 0,
    material_slots_count = 0,
    stationing_offset = {0, 0},
    charging_offsets =
    {
      {0, -1.7},
    },
    base =
    {
      filename = "__RoboCharge__/graphics/Robot-Charge-Station.png",
      width = 136,
      height = 132,
      shift = {1, -0.75}
    },
    base_patch =
    {
      filename = "__RoboCharge__/graphics/1x1.png",
      priority = "low",
      width = 0,
      height = 0,
      frame_count = 1,
      shift = {-0.5315, -1.9375}
    },
    base_animation =
    {
        filename = "__RoboCharge__/graphics/roboport-chargepad.png",
        priority = "medium",
        width = 32,
        height = 32,
        frame_count = 6,
        shift = {0, -2.28125},
        animation_speed = 0.1,
    },
    door_animation =
    {
      filename = "__RoboCharge__/graphics/1x1.png",
      priority = "low",
      width = 0,
      height = 0,
      frame_count = 1,
      shift = {0, -0.6}
    },
    door_animation_up =
    {
      filename = "__RoboCharge__/graphics/1x1.png",
      priority = "low",
      width = 0,
      height = 0,
      frame_count = 1,
      shift = {0, -0.6}
    },
    door_animation_down =
    {
      filename = "__RoboCharge__/graphics/1x1.png",
      priority = "low",
      width = 0,
      height = 0,
      frame_count = 1,
      shift = {0, -0.6}
    },
    recharging_animation =
    {
      filename = "__base__/graphics/entity/roboport/roboport-recharging.png",
      priority = "high",
      width = 37,
      height = 35,
      frame_count = 16,
      scale = 1.5,
      animation_speed = 0.5
    },
	working_sound =
    {
      sound = { filename = "__base__/sound/roboport-working.ogg", volume = 0.4 },
      max_sounds_per_type = 3,
      audible_distance_modifier = 0.3,
      probability = 1 / (5 * 60) -- average pause between the sound is 5 seconds
    },
    recharging_light = {intensity = 0.4, size = 5},
    request_to_open_door_timeout = 15,
    spawn_and_station_height = 0.33,
    radius_visualisation_picture =
    {
      filename = "__base__/graphics/entity/roboport/roboport-radius-visualization.png",
      width = 12,
      height = 12
    },
    construction_radius_visualisation_picture =
    {
      filename = "__base__/graphics/entity/roboport/roboport-construction-radius-visualization.png",
      width = 12,
      height = 12
    }
  }
})