require("defines")
require("config")

local concrete = data.raw["tile"]["concrete"]
if concrete then
	local graphics_path
	
	if concrete_edges_config.use_straight_edges_for_concrete then
		graphics_path = concrete_edges_defines.mod_directory .. "/graphics/terrain/concrete-straight/"
	else
		graphics_path = concrete_edges_defines.mod_directory .. "/graphics/terrain/concrete/"
		
	end
	concrete.variants.inner_corner.picture = graphics_path .. "concrete-inner-corner.png"
	concrete.variants.outer_corner.picture = graphics_path .. "concrete-outer-corner.png"
	concrete.variants.side.picture = graphics_path .. "concrete-side.png"
	concrete.variants.u_transition.picture = graphics_path .. "concrete-u.png"
	concrete.variants.o_transition.picture = graphics_path .. "concrete-o.png"
	if concrete_edges_config.use_straight_edges_for_concrete then
		concrete.variants.o_transition.count = 6
	else
		concrete.variants.o_transition.count = 16
	end
end

local hazard_concrete_left = data.raw["tile"]["hazard-concrete-left"]
if hazard_concrete_left then
	local graphics_path = concrete_edges_defines.mod_directory .. "/graphics/terrain/hazard-concrete-left/"
	hazard_concrete_left.layer = 62 -- Change its layer so the edges of concrete and harzard concrete can blend well.
	hazard_concrete_left.variants.inner_corner.picture = graphics_path .. "hazard-concrete-left-inner-corner.png"
	hazard_concrete_left.variants.outer_corner.picture = graphics_path .. "hazard-concrete-left-outer-corner.png"
	hazard_concrete_left.variants.side.picture = graphics_path .. "hazard-concrete-left-side.png"
	hazard_concrete_left.variants.u_transition.picture = graphics_path .. "hazard-concrete-left-u.png"
	hazard_concrete_left.variants.o_transition.picture = graphics_path .. "hazard-concrete-left-o.png"
	hazard_concrete_left.variants.o_transition.count = 6
end

local hazard_concrete_right = data.raw["tile"]["hazard-concrete-right"]
if hazard_concrete_right then
	local graphics_path = concrete_edges_defines.mod_directory .. "/graphics/terrain/hazard-concrete-right/"
	hazard_concrete_right.layer = 62
	hazard_concrete_right.variants.inner_corner.picture = graphics_path .. "hazard-concrete-right-inner-corner.png"
	hazard_concrete_right.variants.outer_corner.picture = graphics_path .. "hazard-concrete-right-outer-corner.png"
	hazard_concrete_right.variants.side.picture = graphics_path .. "hazard-concrete-right-side.png"
	hazard_concrete_right.variants.u_transition.picture = graphics_path .. "hazard-concrete-right-u.png"
	hazard_concrete_right.variants.o_transition.picture = graphics_path .. "hazard-concrete-right-o.png"
	hazard_concrete_right.variants.o_transition.count = 6
end